package form;

import symphony.beans.producer.*;
import java.util.Vector;
import java.io.*;
import java.net.*;

// ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
// ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
/**
 * A Java bean representing the parameters for a RFP simulation. 
 * @author Modified by Randy Levensalor (Perameters.java)
 * @author Ashish Shah
 */

public class Form
       extends Producer { 
                               
    private transient InputStream inStream ;
    private transient FormLoader idialog_obj = null ;
    private String _cmdArgs = null ;
    private String parameterSet = null ;

    // |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
    // |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
    // ====== Construct the RFP Input Bean =====

    /**
     * Constructs a Parameters Bean with the specified title.
     * @param label the title of the Basic Bean
     */
    public Form () {
       super ( "Form" ) ;
    }

    public String getBeanName() {
      return new String ( "Form" ) ;
    }

   // |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
   // |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

   public InputStream start ()
     throws Exception {

       if ( idialog_obj != null ) {
	 //idialog_obj.dispose () ;
       }                    

       idialog_obj = new FormLoader ( getBeanBoxFrame(), parameterSet ) ;
       _cmdArgs = idialog_obj.getCommandArgs() ;
       inStream = new StringBufferInputStream  ( _cmdArgs );

       // System.out.println ( "\n[" + _cmdArgs + "]" ) ;
       idialog_obj = null ;
       return inStream ;
   }
      
   // |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
   // |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

   public void stop () 
     throws Exception {
       if ( idialog_obj != null ) {
	 //idialog_obj.dispose () ;
       }
       _cmdArgs = null ;
       return ;
   }

   // |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
   // |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
   // == add more verification code here ==

   public boolean verify () 
     throws Exception {
       if ( parameterSet == null ) 
	 throw new Exception ( "ParameterSet is not set " + 
			       "in the input object" );
       return ( true ) ;
   }

   // |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
   // |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
   // ======= Get/Set Description =======

   /** 
    * Set the bean's description. This is a bound property.
    * 
    * @see #getParameterSet
    */
   public void setParameterSet ( String newSet ) {
     String oldSet = parameterSet ;
     parameterSet = newSet ;
     changes.firePropertyChange("parameterSet", oldSet, newSet ) ;
   }

    /**
     * Returns the bean's description
     * 
     * @see #setParameterSet
     */
    public String getParameterSet() {
	return parameterSet ;
    }
}

// ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
// ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

